Subject: Re: [RFC PATCH] net: ethtool: do runtime PM outside RTNL

From: Marc MERLIN <[email-masked]>
Date: Tue, 5 Dec 2023 15:15:09 -0800

On Tue, Dec 05, 2023 at 08:33:02PM +0100, Johannes Berg wrote:
> On Mon, 2023-12-04 at 18:46 -0800, Marc MERLIN wrote:
> > 
> > [13323.572484] iwlwifi 0000:09:00.0: TB bug workaround: copied 152 bytes from 0xffffff68 to 0xfd080000
> > [13328.000825] iwlwifi 0000:09:00.0: TB bug workaround: copied 1272 bytes from 0xfffffb08 to 0xff42c000
> > [13367.278564] iwlwifi 0000:09:00.0: TB bug workaround: copied 1328 bytes from 0xfffffad0 to 0xfec41000
> > [13389.737971] iwlwifi 0000:09:00.0: TB bug workaround: copied 572 bytes from 0xfffffdc4 to 0xff091000
> > [13389.860480] iwlwifi 0000:09:00.0: TB bug workaround: copied 148 bytes from 0xffffff6c to 0xfe412000
> > [13393.435354] iwlwifi 0000:09:00.0: TB bug workaround: copied 360 bytes from 0xfffffe98 to 0xfedcd000
> > [13409.827199] iwlwifi 0000:09:00.0: TB bug workaround: copied 1348 bytes from 0xfffffabc to 0xfd057000
> 
> That's fine, just working around a HW bug on 2^32 address boundaries.
> 
> I had a patch a long time ago to make those messages not appear ... not
> sure where it ended up.

About this wifi chip (AX210/AX211/AX411), one last issue I have with it is when I go to
batteries, it burns a lot of power:
> The battery reports a discharge rate of 36.8 W
> The power consumed was 772 J
> The estimated remaining time is 1 hours, 56 minutes
> 
> Summary: 1657.3 wakeups/second,  0.0 GPU ops/seconds, 0.0 VFS ops/sec and 121.5% CPU use
> 
> Power est.              Usage       Events/s    Category       Description
>   24.1 W     59.6 pkts/s                Device         Network interface: wlp9s0 (iwlwifi)
>   200 mW     80.6%                      Device         Display backlight
>   139 mW      0.0 µs/s      0.00        Process        [PID 8005] /usr/bin/pipewire
>  5.37 mW     18.0 ms/s     537.1        Timer          tick_sched_timer
> 
> 
> The battery reports a discharge rate of 36.1 W
> The power consumed was 744 J
> System baseline power is estimated at 28.9 W
> 
> Power est.    Usage     Device name
>   24.0 W    100.0%        Radio device: iwlwifi
>   4.43 W    205.2%        CPU core
>   230 mW    100.0%        Audio codec alsa:hwC0D0: thinkpad (Realtek) (pipewire )
> 
> autosuspend is on:
>    Good          Runtime PM for PCI Device Intel Corporation Wi-Fi 6 AX210/AX211/AX411 160MHz

Obviously unloading iwlwifi fixes it:
> The battery reports a discharge rate of 26.0 W
> The power consumed was 534 J
> The estimated remaining time is 2 hours, 40 minutes
> 
> Summary: 927.2 wakeups/second,  0.0 GPU ops/seconds, 0.0 VFS ops/sec and 85.5% CPU use
> 
> Power est.              Usage       Events/s    Category       Description
>   6.95 W    100.0%                      Device         USB device: Yubico Gnubby (gnubby1) (Yubico)
>   2.09 W      0.0 µs/s      0.00        Process        [PID 8005] /usr/bin/pipewire
>   185 mW     80.6%                      Device         Display backlight
> 
> The battery reports a discharge rate of 26.0 W
> The power consumed was 534 J
> System baseline power is estimated at 11.5 W
> 
> Power est.    Usage     Device name
>   6.95 W    100.0%        USB device: Yubico Gnubby (gnubby1) (Yubico)
>   2.09 W    100.0%        Audio codec alsa:hwC0D0: thinkpad (Realtek) (pipewire )
>   2.02 W     85.5%        CPU core

What's very interesting is if I re-insert the iwlwifi module after that, 
it works and used a lot less power last time I tried, but this time around
it's still shown as high although probably with a wrong Watt value because powertop
is confused somehow:
  28.8 W    470.9 pkts/s                Device         Network interface: wlp9s0 (iwlwifi)

  24.4 W    100.0%        Radio device: iwlwifi

Is this something I should persue separately on
[email-masked] or [email-masked] or elsewhere?

Thanks,
Marc
-- 
"A mouse is a device used to point at the xterm you want to type in" - A.S.R.
 
Home page: http://marc.merlins.org/                       | PGP 7F55D5F27AAF9D08